## libnc-dap 3.5.1-1

=== debian/changelog ===
libnc-dap (3.5.1-1) unstable; urgency=low

  * Initial Release.

 -- ODAKA Masatsugu <odakker@gfd-dennou.org>  Sun, 24 Jul 2005 12:27:30 +0900
