=== debian/control ===
Source: libnc-dap
Section: science
Priority: optional
Maintainer: ODAKA Masatsugu <odakker@gfd-dennou.org>
Build-Depends: debhelper (>= 4.0.0), autotools-dev
Standards-Version: 3.6.1

Package: libnc-dap
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdap (>= 3.5.1)
Build-Depends:  libcurl3-dev, libxml2-dev, dejagnu, cppunit
Description: NetCDF Library with OPeNDAP URLs extentions.
 The netCDF Client Library is an alternative implementation of Unidata's netCDF 3.5 API. This version adds the capability to dereference OPeNDAP URLs. You can substitute our version of the library when linking your application and then simply pass an OPeNDAP URL in where you would normally use a file name.
