## libnc-dap 3.7.2

=== VCPP/Makefile ===
--- 
+++ 
@@ -1,16 +1,41 @@
-# Makefile for libnc-dods (under VC++ on win32)
-
-# Setup some preliminary directories
+# Makefile for libnc-dap (under VC++ on win32)
+
+# Source code, samples, docs and target build areas
 OBJDIR			= .\objects
 SRCDIR			= ..
-ROOTINSTALLDIR	= ..\..\prepkg
-INSTALLLIBDIR	= $(ROOTINSTALLDIR)\lib
-INSTALLDLLDIR	= $(ROOTINSTALLDIR)\dll
-INSTALLBINDIR	= $(ROOTINSTALLDIR)\bin
-INSTALLETCDIR	= $(ROOTINSTALLDIR)\etc
-INSTALLINCDIR	= $(ROOTINSTALLDIR)\include
-
-INCLUDEDIR	= $(ROOTINSTALLDIR)\include
+DOCDIR			= .\doc
+SAMPLEDIR		= .\sample
+
+# This is the prepackaging area.  Contents should never be on the build path.
+# Fill in the VERSION (e.g., "= 3.7.0") to generate a final, version stamped
+# release of the product.
+PRODUCT			= libnc-dap
+VERSION			=
+PKGDIR			= ..\..\prepkg\opendap\$(PRODUCT)$(VERSION)
+PKGLIBDIR		= $(PKGDIR)\lib
+PKGDLLDIR		= $(PKGDIR)\dll
+PKGBINDIR		= $(PKGDIR)\bin
+PKGETCDIR		= $(PKGDIR)\etc
+PKGINCDIR		= $(PKGDIR)\include
+PKGSAMPLEDIR	= $(PKGDIR)\sample
+
+# This is the installation area.  Select directories should be on the build
+# in order to pick up the OPeNDAP Core headers and libraries.
+INSTALLDIR		= ..\..
+INSTALLLIBDIR	= $(INSTALLDIR)\lib
+INSTALLDLLDIR	= $(INSTALLDIR)\dll
+INSTALLBINDIR	= $(INSTALLDIR)\bin
+INSTALLINCDIR	= $(INSTALLDIR)\include
+
+# libnc-dap headers come from the source distribution itself and not
+# from here as headers in the libnc-dap sources are picked up first.
+# This is here to allow the Core headers to be located.
+INCLUDEDIR		= $(INSTALLINCDIR)
+
+# libnc-dap libraries come from libnc-dap build directories themselves
+# and not from here as libraries from the build dirs are picked up first.
+# This is here to allow the Core libraries to be located.
+LIBDIR			= $(INSTALLLIBDIR)
 
 # Compiler, Linker
 CC		= cl
@@ -25,46 +50,47 @@
 CFLAGS		= /nologo /W0 /GR /EHsc /c
 
 # Setup linker flags for libraries
-MTLFLAGS	= -lib /nologo -libpath:$(INSTALLLIBDIR)
-MDLFLAGS	= -libpath:$(INSTALLLIBDIR) /dll /def:libnc-dods.def /map /fixed:NO /base:0x07000000 /NODEFAULTLIB:LIBCMT.lib
-
-# Link libraries for libnc-dods
+MTLFLAGS	= -lib /nologo -libpath:$(OBJDIR)\MT -libpath:$(LIBDIR)
+MDLFLAGS	= /nologo -libpath:$(OBJDIR)\MD -libpath:$(LIBDIR) /dll /def:libnc-dap.def /map /fixed:NO /base:0x07000000 /NODEFAULTLIB:LIBCMT.lib
+
+# Link libraries for libnc-dap
 MTLIBS		=
 MDLIBS		= libdapclientMD.lib libdapserverMD.lib libdapMD.lib libxml2.lib libcurl.lib zlib.lib libxdr.lib pthreadVC.lib
 
 # Setup linker flags for executables
-EMTLFLAGS	= /nologo /libpath:$(INSTALLLIBDIR) /NODEFAULTLIB:MSVCRT.lib
-EMDLFLAGS	= /nologo /libpath:$(INSTALLLIBDIR)
+EMTLFLAGS	= /nologo -libpath:$(OBJDIR)\MT -libpath:$(LIBDIR) /NODEFAULTLIB:MSVCRT.lib
+EMDLFLAGS	= /nologo -libpath:$(OBJDIR)\MD -libpath:$(LIBDIR) /NODEFAULTLIB:LIBCMT.lib
 
 # Link libraries for executables
-EMTLLIBS	= libdapclientMT.lib libdapserverMT.lib libdapMT.lib libnc-dodsMT.lib libxml2.lib libcurl.lib zlib.lib libxdr.lib libgetopt.lib pthreadVC.lib
-EMDLLIBS	= libdapclientMD.lib libdapserverMD.lib libdapMD.lib libnc-dodsMD.lib libxml2.lib libcurl.lib zlib.lib libxdr.lib libgetopt.lib pthreadVC.lib
+EMTLLIBS	= libdapclientMT.lib libdapserverMT.lib libdapMT.lib libnc-dapMT.lib libxml2.lib libcurl.lib zlib.lib libxdr.lib libgetopt.lib pthreadVC.lib
+EMDLLIBS	= libdapclientMD.lib libdapserverMD.lib libdapMD.lib libnc-dapMD.lib libxml2.lib libcurl.lib zlib.lib libxdr.lib libgetopt.lib pthreadVC.lib
 
 # Setup compiler includes and defines
 INCS		= /I . /I ..\lnetcdf /I ..\fortran /I .. /I $(INCLUDEDIR) /I $(INCLUDEDIR)\GNU
-DEFS		= /D WIN32 /D WIN32_LEAN_AND_MEAN /D LOCAL
+DEFS		= /D WIN32 /D WIN32_LEAN_AND_MEAN /D LOCAL /D HAVE_CONFIG_H
 CPPFLAGS	= $(DEFS) $(INCS)
 
 usage:
-	@echo "usage: nmake all; nmake install"
-	@echo "or"
-	@echo "usage: nmake model<MT|MD>; nmake installMT|MD|>"
-
-all:	setup modelMT modelMD
-
-modelMT: setup
+	@echo "usage: nmake all; nmake install; nmake package"
+
+all:	modelMT modelMD
+
+modelMT:
 	@-md $(OBJDIR)\MT
-	nmake /NOLOGO CFLAGS="$(CFLAGS) $(MTCFLAGS)" LFLAGS="$(MTLFLAGS)" LIBS="$(MTLIBS)" OBJDIR=$(OBJDIR)\MT libnc-dodsMT.lib
-	nmake /NOLOGO installMT
-
-	nmake /NOLOGO CFLAGS="$(CFLAGS) $(MTCFLAGS)" LFLAGS="$(EMTLFLAGS)" LIBS="$(EMTLLIBS)" OBJDIR=$(OBJDIR)\MT dncdump
-
-modelMD: setup
+	@echo "Building MT model library for the libnc-dap"
+	@nmake /NOLOGO CFLAGS="$(CFLAGS) $(MTCFLAGS)" LFLAGS="$(MTLFLAGS)" LIBS="$(MTLIBS)" OBJDIR=$(OBJDIR)\MT libnc-dapMT.lib
+	@echo "MT model libraries for the Core are complete"
+
+	@nmake /NOLOGO CFLAGS="$(CFLAGS) $(MTCFLAGS)" LFLAGS="$(EMTLFLAGS)" LIBS="$(EMTLLIBS)" OBJDIR=$(OBJDIR)\MT dncdump
+	@echo "MT model library for libnc-dap is complete"
+	
+modelMD:
 	@-md $(OBJDIR)\MD
-	nmake /NOLOGO CFLAGS="$(CFLAGS) $(MDCFLAGS)" LFLAGS="$(MDLFLAGS)" LIBS="$(MDLIBS)" OBJDIR=$(OBJDIR)\MD libnc-dodsMD.dll
-	nmake /NOLOGO installMD
-
-	nmake /NOLOGO CFLAGS="$(CFLAGS) $(MDCFLAGS)" LFLAGS="$(EMDLFLAGS)" LIBS="$(EMDLLIBS)" OBJDIR=$(OBJDIR)\MD dncdump
+	@echo "Building MD model library for the libnc-dap"
+	@nmake /NOLOGO CFLAGS="$(CFLAGS) $(MDCFLAGS)" LFLAGS="$(MDLFLAGS)" LIBS="$(MDLIBS)" OBJDIR=$(OBJDIR)\MD libnc-dapMD.dll
+
+	@nmake /NOLOGO CFLAGS="$(CFLAGS) $(MDCFLAGS)" LFLAGS="$(EMDLFLAGS)" LIBS="$(EMDLLIBS)" OBJDIR=$(OBJDIR)\MD dncdump
+	@echo "MD model library for libnc-dap is complete"
 
 # Clear built-in rules and set new ones
 .SUFFIXES :
@@ -144,21 +170,35 @@
 	$(OBJDIR)\dumplib.obj
 
 # Convenience dependancies
-libnc-dodsMT.lib: $(OBJDIR)\libnc-dodsMT.lib
-libnc-dodsMD.dll: $(OBJDIR)\libnc-dodsMD.dll
+libnc-dapMT.lib: $(OBJDIR)\libnc-dapMT.lib
+libnc-dapMD.dll: $(OBJDIR)\libnc-dapMD.dll
 
 dncdump: $(OBJDIR)\dncdump.exe
 	@echo "built dncdump"
 
 # Link the library
-$(OBJDIR)\libnc-dodsMT.lib: $(LIBOBJS) $(NCOBJS) $(FOBJS)
+$(OBJDIR)\libnc-dapMT.lib: $(LIBOBJS) $(NCOBJS) $(FOBJS)
 	$(LINK) $(LFLAGS) /out:$@ $(LIBOBJS) $(NCOBJS) $(FOBJS) $(LIBS) 
 
-$(OBJDIR)\libnc-dodsMD.dll: $(LIBOBJS) $(NCOBJS) $(FOBJS)
-	$(LINK) $(LFLAGS) /out:$@ $(LIBOBJS) $(NCOBJS) $(FOBJS) $(LIBS)
+############################################################################
+# We're not currently using the trick where we build the module export
+# definitions on the fly for this library (see the Core makefile for win32
+# for an example of such a thing).  There are lots of global vars and other
+# issues to contend with here and that makes it at least more difficult.
+# We're going with a libnc-dap.def that was generated by mingw's 'dlltool'
+# and hand edited such that it allows the build of the dll.
+############################################################################
+
+$(OBJDIR)\libnc-dapMD.dll: $(LIBOBJS) $(NCOBJS) $(FOBJS)
+	$(LINK) $(LFLAGS) /out:$@ $** $(LIBS) 
 
 $(OBJDIR)\dncdump.exe: $(EXEOBJS)
 	$(LINK) $(LFLAGS) /libpath:$(OBJDIR) /out:$@ $(EXEOBJS) $(LIBS)
+	
+# Target not for general use.  Requires hand editing of libnc-dap.def.  It's
+# just here for reference.
+libncdap.def:
+	dlltool --export-all-symbols --outputdef libnc-dap.def $(LIBOBJS) $(NCOBJS) $(FOBJS)
 
 # Dods Netcdf Objects
 $(OBJDIR)\NCArray.obj		: $(SRCDIR)\NCAccess.cc
@@ -222,30 +262,56 @@
 $(OBJDIR)\vardata.obj		: $(SRCDIR)\ncdump\vardata.c
 $(OBJDIR)\dumplib.obj		: $(SRCDIR)\ncdump\dumplib.c
 
-# Preliminary setup
-setup:
-	@-mkdir $(OBJDIR)
-	@-mkdir $(INSTALLBINDIR)
-	@-mkdir $(INSTALLETCDIR)
-	@-mkdir $(INSTALLLIBDIR)
-	@-mkdir $(INSTALLDLLDIR)
-	@-mkdir $(INSTALLINCDIR)
-
-# Install
-install: installMT installMD
-	copy $(OBJDIR)\MT\dncdump.exe $(INSTALLBINDIR)
+# The mt command embeds the manifest in the executable
+install: all mkinstdirs
+	copy $(OBJDIR)\MT\libnc-dapMT.lib $(INSTALLLIBDIR)
+
+	copy $(OBJDIR)\MD\libnc-dapMD.dll* $(INSTALLDLLDIR)
+	mt -nologo -manifest $(INSTALLDLLDIR)\libnc-dapMD.dll.manifest -outputresource:$(INSTALLDLLDIR)\libnc-dapMD.dll;2
+	del $(INSTALLDLLDIR)\libnc-dapMD.dll.manifest
+	copy $(OBJDIR)\MD\libnc-dapMD.lib $(INSTALLLIBDIR)
+
+	copy $(OBJDIR)\MD\dncdump.exe* $(INSTALLBINDIR)
+	mt -nologo -manifest $(INSTALLBINDIR)\dncdump.exe.manifest -outputresource:$(INSTALLBINDIR)\dncdump.exe;1
+	del $(INSTALLBINDIR)\dncdump.exe.manifest
+
 	copy ..\lnetcdf\netcdf.h $(INSTALLINCDIR)
 	copy ..\fortran\netcdf.inc $(INSTALLINCDIR)
-
-installMT:
-	copy $(OBJDIR)\MT\libnc-dodsMT.lib $(INSTALLLIBDIR)
-
-installMD:
-	copy $(OBJDIR)\MD\libnc-dodsMD.lib $(INSTALLLIBDIR)
-	copy $(OBJDIR)\MD\libnc-dodsMD.dll $(INSTALLDLLDIR)
+	
+package: all mkpkgdirs document
+	copy $(OBJDIR)\MT\libnc-dapMT.lib $(PKGLIBDIR)
+
+	copy $(OBJDIR)\MD\libnc-dapMD.dll* $(PKGDLLDIR)
+	mt -nologo -manifest $(PKGDLLDIR)\libnc-dapMD.dll.manifest -outputresource:$(PKGDLLDIR)\libnc-dapMD.dll;2
+	del $(PKGDLLDIR)\libnc-dapMD.dll.manifest
+	copy $(OBJDIR)\MD\libnc-dapMD.lib $(PKGLIBDIR)
+
+	copy $(OBJDIR)\MD\dncdump.exe* $(PKGBINDIR)
+	mt -nologo -manifest $(PKGBINDIR)\dncdump.exe.manifest -outputresource:$(PKGBINDIR)\dncdump.exe;1
+	del $(PKGBINDIR)\dncdump.exe.manifest
+
+	copy ..\lnetcdf\netcdf.h $(PKGINCDIR)
+	copy ..\fortran\netcdf.inc $(PKGINCDIR)
+
+mkinstdirs:	
+	@-md $(INSTALLLIBDIR)
+	@-md $(INSTALLBINDIR)
+	@-md $(INSTALLDLLDIR)
+	@-md $(INSTALLINCDIR)
+	
+mkpkgdirs:	
+	@-md $(PKGLIBDIR)
+	@-md $(PKGBINDIR)
+	@-md $(PKGDLLDIR)
+	@-md $(PKGINCDIR)
+
+document:
+	@-md $(PKGSAMPLEDIR)
+	copy $(SAMPLEDIR)\* $(PKGSAMPLEDIR)
+	copy $(DOCDIR)\readme.txt $(PKGDIR)
 
 clean:
-	@-rd /Q /S $(OBJDIR)
+	@-rd /Q /S $(OBJDIR) $(PKGDIR)
 
 !INCLUDE "dependancies"
